From e3d0f8741158b1b4520dbe753f8e7cd5b996c4fa Mon Sep 17 00:00:00 2001
From: Mark Dilger <mark.dilger@enterprisedb.com>
Date: Tue, 26 May 2020 14:22:00 -0700
Subject: [PATCH v1] Implementing new 'pg' consolidated metacommand

This implements a new command to consolidate disparate postgres
command line programs into one.
---
 contrib/sepgsql/test_sepgsql                  |   1 +
 contrib/start-scripts/freebsd                 |   2 +-
 contrib/start-scripts/linux                   |   2 +-
 .../start-scripts/macos/postgres-wrapper.sh   |   4 +-
 doc/src/sgml/ref/pgupgrade.sgml               |  22 +-
 src/Makefile.global.in                        |  10 +-
 src/backend/postmaster/postmaster.c           |   7 +-
 src/backend/utils/init/globals.c              |   1 +
 src/backend/utils/init/miscinit.c             |   7 +
 src/backend/utils/misc/pg_config.c            |   3 +-
 src/bin/Makefile                              |   1 +
 src/bin/initdb/Makefile                       |   6 +-
 src/bin/initdb/initdb.c                       |   4 +-
 src/bin/initdb/t/002_redirect.pl              |  17 ++
 src/bin/pg/.gitignore                         |   4 +
 src/bin/pg/Makefile                           |  48 +++++
 src/bin/pg/pg.c                               | 194 ++++++++++++++++++
 src/bin/pg/t/001_basic.pl                     |  31 +++
 src/bin/pg_archivecleanup/Makefile            |   6 +-
 src/bin/pg_archivecleanup/t/001_redirect.pl   |  17 ++
 .../t/010_pg_archivecleanup.pl                |  10 +-
 src/bin/pg_basebackup/Makefile                |  14 +-
 src/bin/pg_basebackup/t/001_redirect.pl       |  17 ++
 src/bin/pg_basebackup/t/010_pg_basebackup.pl  |  72 +++----
 src/bin/pg_basebackup/t/020_pg_receivewal.pl  |  14 +-
 src/bin/pg_basebackup/t/030_pg_recvlogical.pl |   8 +-
 src/bin/pg_checksums/Makefile                 |   6 +-
 src/bin/pg_checksums/t/002_actions.pl         |  38 ++--
 src/bin/pg_checksums/t/003_redirect.pl        |  17 ++
 src/bin/pg_config/Makefile                    |   6 +-
 src/bin/pg_config/pg_config.c                 |  16 +-
 src/bin/pg_config/t/001_pg_config.pl          |  12 +-
 src/bin/pg_controldata/Makefile               |   6 +-
 .../pg_controldata/t/001_pg_controldata.pl    |   8 +-
 src/bin/pg_controldata/t/002_redirect.pl      |  17 ++
 src/bin/pg_ctl/Makefile                       |   6 +-
 src/bin/pg_ctl/pg_ctl.c                       |  12 +-
 src/bin/pg_ctl/t/001_start_stop.pl            |  22 +-
 src/bin/pg_ctl/t/002_status.pl                |  10 +-
 src/bin/pg_ctl/t/003_promote.pl               |  10 +-
 src/bin/pg_ctl/t/005_redirect.pl              |  17 ++
 src/bin/pg_dump/Makefile                      |  10 +-
 src/bin/pg_dump/pg_dumpall.c                  |   4 +-
 src/bin/pg_dump/t/004_redirect.pl             |  17 ++
 src/bin/pg_resetwal/Makefile                  |   6 +-
 src/bin/pg_resetwal/t/003_redirect.pl         |  17 ++
 src/bin/pg_rewind/Makefile                    |   6 +-
 src/bin/pg_rewind/pg_rewind.c                 |  12 +-
 src/bin/pg_rewind/t/007_redirect.pl           |  17 ++
 src/bin/pg_test_fsync/Makefile                |   6 +-
 src/bin/pg_test_timing/Makefile               |   6 +-
 src/bin/pg_upgrade/Makefile                   |   8 +-
 src/bin/pg_upgrade/TESTING                    |   2 +
 src/bin/pg_upgrade/check.c                    |   6 +-
 src/bin/pg_upgrade/controldata.c              |   4 +-
 src/bin/pg_upgrade/dump.c                     |   8 +-
 src/bin/pg_upgrade/exec.c                     | 119 ++++++-----
 src/bin/pg_upgrade/option.c                   |  66 ++++--
 src/bin/pg_upgrade/pg_upgrade.c               |  73 ++++---
 src/bin/pg_upgrade/pg_upgrade.h               |  13 ++
 src/bin/pg_upgrade/server.c                   |   8 +-
 src/bin/pg_upgrade/test.sh                    |  13 +-
 src/bin/pg_verifybackup/Makefile              |   6 +-
 src/bin/pg_verifybackup/pg_verifybackup.c     |   6 +-
 src/bin/pg_verifybackup/t/008_redirect.pl     |  17 ++
 src/bin/pg_waldump/Makefile                   |   6 +-
 src/bin/pg_waldump/t/002_redirect.pl          |  17 ++
 src/bin/pgbench/Makefile                      |   6 +-
 src/bin/pgbench/t/003_redirect.pl             |  17 ++
 src/bin/psql/startup.c                        |   9 +-
 src/bin/scripts/Makefile                      |  20 +-
 src/common/.gitignore                         |   1 +
 src/common/Makefile                           |   8 +-
 src/common/config_info.c                      |  28 ++-
 src/common/exec.c                             | 143 ++++++++++++-
 src/common/mk_exec_relpath.pl                 |  85 ++++++++
 src/include/common/config_info.h              |   1 +
 src/include/miscadmin.h                       |   1 +
 src/include/port.h                            |  20 +-
 src/interfaces/ecpg/test/Makefile             |  10 +-
 src/port/Makefile                             |   1 +
 src/port/path.c                               | 103 ++++++++--
 src/test/isolation/isolation_main.c           |   8 +-
 src/test/regress/pg_regress.c                 |  39 ++--
 src/tools/msvc/Solution.pm                    |   1 +
 src/tools/msvc/vcregress.pl                   |   2 +
 86 files changed, 1336 insertions(+), 365 deletions(-)
 create mode 100644 src/bin/initdb/t/002_redirect.pl
 create mode 100644 src/bin/pg/.gitignore
 create mode 100644 src/bin/pg/Makefile
 create mode 100644 src/bin/pg/pg.c
 create mode 100644 src/bin/pg/t/001_basic.pl
 create mode 100644 src/bin/pg_archivecleanup/t/001_redirect.pl
 create mode 100644 src/bin/pg_basebackup/t/001_redirect.pl
 create mode 100644 src/bin/pg_checksums/t/003_redirect.pl
 create mode 100644 src/bin/pg_controldata/t/002_redirect.pl
 create mode 100644 src/bin/pg_ctl/t/005_redirect.pl
 create mode 100644 src/bin/pg_dump/t/004_redirect.pl
 create mode 100644 src/bin/pg_resetwal/t/003_redirect.pl
 create mode 100644 src/bin/pg_rewind/t/007_redirect.pl
 create mode 100644 src/bin/pg_verifybackup/t/008_redirect.pl
 create mode 100644 src/bin/pg_waldump/t/002_redirect.pl
 create mode 100644 src/bin/pgbench/t/003_redirect.pl
 create mode 100755 src/common/mk_exec_relpath.pl

diff --git a/contrib/sepgsql/test_sepgsql b/contrib/sepgsql/test_sepgsql
index 3a29556d1f..b2dc566994 100755
--- a/contrib/sepgsql/test_sepgsql
+++ b/contrib/sepgsql/test_sepgsql
@@ -13,6 +13,7 @@
 #
 
 PG_BINDIR=`pg_config --bindir`
+PG_LIBEXECDIR=`pg_config --libexecdir`
 
 # we must move to contrib/sepgsql directory to run pg_regress correctly
 cd `dirname $0`
diff --git a/contrib/start-scripts/freebsd b/contrib/start-scripts/freebsd
index 3323237a54..febb8862e9 100644
--- a/contrib/start-scripts/freebsd
+++ b/contrib/start-scripts/freebsd
@@ -32,7 +32,7 @@ PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
 DAEMON="$prefix/bin/postmaster"
 
 # What to use to shut down the postmaster
-PGCTL="$prefix/bin/pg_ctl"
+PGCTL="$prefix/libexec/pg_ctl"
 
 # Only start if we can find the postmaster.
 test -x $DAEMON ||
diff --git a/contrib/start-scripts/linux b/contrib/start-scripts/linux
index a7757162fc..9425ba2453 100644
--- a/contrib/start-scripts/linux
+++ b/contrib/start-scripts/linux
@@ -64,7 +64,7 @@ PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
 DAEMON="$prefix/bin/postmaster"
 
 # What to use to shut down the postmaster
-PGCTL="$prefix/bin/pg_ctl"
+PGCTL="$prefix/libexec/pg_ctl"
 
 set -e
 
diff --git a/contrib/start-scripts/macos/postgres-wrapper.sh b/contrib/start-scripts/macos/postgres-wrapper.sh
index 3a4ebdaf0f..2be058480e 100644
--- a/contrib/start-scripts/macos/postgres-wrapper.sh
+++ b/contrib/start-scripts/macos/postgres-wrapper.sh
@@ -4,8 +4,10 @@
 
 # edit these as needed:
 
-# directory containing postgres executable:
+# directory containing postgres user executable:
 PGBINDIR="/usr/local/pgsql/bin"
+# directory containing postgres program executables:
+PGLIBEXECDIR="/usr/local/pgsql/libexec"
 # data directory:
 PGDATA="/usr/local/pgsql/data"
 # file to receive postmaster's initial log messages:
diff --git a/doc/src/sgml/ref/pgupgrade.sgml b/doc/src/sgml/ref/pgupgrade.sgml
index 905167690b..5c2a6fa242 100644
--- a/doc/src/sgml/ref/pgupgrade.sgml
+++ b/doc/src/sgml/ref/pgupgrade.sgml
@@ -26,6 +26,10 @@ PostgreSQL documentation
    <arg choice="plain"><replaceable>oldbindir</replaceable></arg>
    <arg choice="plain"><option>-B</option></arg>
    <arg choice="plain"><replaceable>newbindir</replaceable></arg>
+   <arg choice="plain"><option>-l</option></arg>
+   <arg choice="plain"><replaceable>oldlibexecdir</replaceable></arg>
+   <arg choice="plain"><option>-L</option></arg>
+   <arg choice="plain"><replaceable>newlibexecdir</replaceable></arg>
    <arg choice="plain"><option>-d</option></arg>
    <arg choice="plain"><replaceable>oldconfigdir</replaceable></arg>
    <arg choice="plain"><option>-D</option></arg>
@@ -92,7 +96,6 @@ PostgreSQL documentation
       <term><option>-B</option> <replaceable>bindir</replaceable></term>
       <term><option>--new-bindir=</option><replaceable>bindir</replaceable></term>
       <listitem><para>the new PostgreSQL executable directory;
-      default is the directory where <application>pg_upgrade</application> resides;
       environment variable <envar>PGBINNEW</envar></para></listitem>
      </varlistentry>
 
@@ -130,6 +133,21 @@ PostgreSQL documentation
       cluster</para></listitem>
      </varlistentry>
 
+     <varlistentry>
+      <term><option>-l</option> <replaceable>libexecdir</replaceable></term>
+      <term><option>--old-libexecdir=</option><replaceable>libexecdir</replaceable></term>
+      <listitem><para>the old PostgreSQL command directory;
+      environment variable <envar>PGLIBEXECOLD</envar></para></listitem>
+     </varlistentry>
+
+     <varlistentry>
+      <term><option>-L</option> <replaceable>libexecdir</replaceable></term>
+      <term><option>--new-libexecdir=</option><replaceable>libexecdir</replaceable></term>
+      <listitem><para>the new PostgreSQL command directory;
+      default is the directory where <application>pg_upgrade</application> resides;
+      environment variable <envar>PGLIBEXECNEW</envar></para></listitem>
+     </varlistentry>
+
      <varlistentry>
       <term><option>-o</option> <replaceable class="parameter">options</replaceable></term>
       <term><option>--old-options</option> <replaceable class="parameter">options</replaceable></term>
@@ -418,6 +436,8 @@ pg_upgrade.exe
         --new-datadir "C:/Program Files/PostgreSQL/&majorversion;/data"
         --old-bindir "C:/Program Files/PostgreSQL/9.6/bin"
         --new-bindir "C:/Program Files/PostgreSQL/&majorversion;/bin"
+        --old-libexecdir "C:/Program Files/PostgreSQL/9.6/libexec"
+        --new-libexecdir "C:/Program Files/PostgreSQL/&majorversion;/libexec"
 </programlisting>
 
      Once started, <command>pg_upgrade</command> will verify the two clusters are compatible
diff --git a/src/Makefile.global.in b/src/Makefile.global.in
index 9a6265b3a0..b0692f40fb 100644
--- a/src/Makefile.global.in
+++ b/src/Makefile.global.in
@@ -99,6 +99,7 @@ exec_prefix := @exec_prefix@
 datarootdir := @datarootdir@
 
 bindir := @bindir@
+libexecdir := @libexecdir@
 
 datadir := @datadir@
 ifeq "$(findstring pgsql, $(datadir))" ""
@@ -153,6 +154,7 @@ PG_CONFIG = pg_config
 endif
 
 bindir := $(shell $(PG_CONFIG) --bindir)
+libexecdir := $(shell $(PG_CONFIG) --libexecdir)
 datadir := $(shell $(PG_CONFIG) --sharedir)
 sysconfdir := $(shell $(PG_CONFIG) --sysconfdir)
 libdir := $(shell $(PG_CONFIG) --libdir)
@@ -438,7 +440,7 @@ ld_library_path_var = LD_LIBRARY_PATH
 # need something more here. If not defined then the expansion does
 # nothing.
 with_temp_install = \
-	PATH="$(abs_top_builddir)/tmp_install$(bindir):$$PATH" \
+	PATH="$(abs_top_builddir)/tmp_install$(bindir):$(abs_top_builddir)/tmp_install$(libexecdir):$$PATH" \
 	$(call add_to_path,$(strip $(ld_library_path_var)),$(abs_top_builddir)/tmp_install$(libdir)) \
 	$(with_temp_install_extra)
 
@@ -447,7 +449,7 @@ ifeq ($(enable_tap_tests),yes)
 define prove_installcheck
 rm -rf '$(CURDIR)'/tmp_check
 $(MKDIR_P) '$(CURDIR)'/tmp_check
-cd $(srcdir) && TESTDIR='$(CURDIR)' PATH="$(bindir):$$PATH" PGPORT='6$(DEF_PGPORT)' top_builddir='$(CURDIR)/$(top_builddir)' PG_REGRESS='$(CURDIR)/$(top_builddir)/src/test/regress/pg_regress' REGRESS_SHLIB='$(abs_top_builddir)/src/test/regress/regress$(DLSUFFIX)' $(PROVE) $(PG_PROVE_FLAGS) $(PROVE_FLAGS) $(if $(PROVE_TESTS),$(PROVE_TESTS),t/*.pl)
+cd $(srcdir) && TESTDIR='$(CURDIR)' PATH="$(bindir):$(libexecdir):$$PATH" PGPORT='6$(DEF_PGPORT)' top_builddir='$(CURDIR)/$(top_builddir)' PG_REGRESS='$(CURDIR)/$(top_builddir)/src/test/regress/pg_regress' REGRESS_SHLIB='$(abs_top_builddir)/src/test/regress/regress$(DLSUFFIX)' $(PROVE) $(PG_PROVE_FLAGS) $(PROVE_FLAGS) $(if $(PROVE_TESTS),$(PROVE_TESTS),t/*.pl)
 endef
 
 define prove_check
@@ -644,12 +646,14 @@ pg_regress_check = \
     $(top_builddir)/src/test/regress/pg_regress \
     --temp-instance=./tmp_check \
     --inputdir=$(srcdir) \
+    --libexecdir= \
     --bindir= \
     $(TEMP_CONF) \
     $(pg_regress_locale_flags) $(EXTRA_REGRESS_OPTS)
 pg_regress_installcheck = \
     $(top_builddir)/src/test/regress/pg_regress \
     --inputdir=$(srcdir) \
+    --libexecdir='$(libexecdir)' \
     --bindir='$(bindir)' \
     $(pg_regress_locale_flags) $(EXTRA_REGRESS_OPTS)
 
@@ -658,12 +662,14 @@ pg_isolation_regress_check = \
     $(top_builddir)/src/test/isolation/pg_isolation_regress \
     --temp-instance=./tmp_check_iso \
     --inputdir=$(srcdir) --outputdir=output_iso \
+    --libexecdir= \
     --bindir= \
     $(TEMP_CONF) \
     $(pg_regress_locale_flags) $(EXTRA_REGRESS_OPTS)
 pg_isolation_regress_installcheck = \
     $(top_builddir)/src/test/isolation/pg_isolation_regress \
     --inputdir=$(srcdir) --outputdir=output_iso \
+    --libexecdir='$(libexecdir)' \
     --bindir='$(bindir)' \
     $(pg_regress_locale_flags) $(EXTRA_REGRESS_OPTS)
 
diff --git a/src/backend/postmaster/postmaster.c b/src/backend/postmaster/postmaster.c
index 160afe9f39..5f7633df94 100644
--- a/src/backend/postmaster/postmaster.c
+++ b/src/backend/postmaster/postmaster.c
@@ -1468,10 +1468,13 @@ getInstallationPaths(const char *argv0)
 	if (find_my_exec(argv0, my_exec_path) < 0)
 		elog(FATAL, "%s: could not locate my own executable path", argv0);
 
+	if (find_my_rootdir(argv0, my_rootdir) < 0)
+		elog(FATAL, "%s: could not locate my own root directory", argv0);
+
 #ifdef EXEC_BACKEND
 	/* Locate executable backend before we change working directory */
-	if (find_other_exec(argv0, "postgres", PG_BACKEND_VERSIONSTR,
-						postgres_exec_path) < 0)
+	if (find_other_cmd(argv0, "postgres", PG_BACKEND_VERSIONSTR,
+					   postgres_exec_path) < 0)
 		ereport(FATAL,
 				(errmsg("%s: could not locate matching postgres executable",
 						argv0)));
diff --git a/src/backend/utils/init/globals.c b/src/backend/utils/init/globals.c
index eb19644419..3b0a2e84a6 100644
--- a/src/backend/utils/init/globals.c
+++ b/src/backend/utils/init/globals.c
@@ -70,6 +70,7 @@ int			data_directory_mode = PG_DIR_MODE_OWNER;
 char		OutputFileName[MAXPGPATH];	/* debugging output file */
 
 char		my_exec_path[MAXPGPATH];	/* full path to my executable */
+char		my_rootdir[MAXPGPATH];		/* full path to postgres root directory */
 char		pkglib_path[MAXPGPATH]; /* full path to lib directory */
 
 #ifdef EXEC_BACKEND
diff --git a/src/backend/utils/init/miscinit.c b/src/backend/utils/init/miscinit.c
index cca9704d2d..01e82f227f 100644
--- a/src/backend/utils/init/miscinit.c
+++ b/src/backend/utils/init/miscinit.c
@@ -161,6 +161,13 @@ InitStandaloneProcess(const char *argv0)
 				 argv0);
 	}
 
+	if (my_rootdir[0] == '\0')
+	{
+		if (find_my_rootdir(argv0, my_rootdir) < 0)
+			elog(FATAL, "%s: could not locate my own installation root",
+				 argv0);
+	}
+
 	if (pkglib_path[0] == '\0')
 		get_pkglib_path(my_exec_path, pkglib_path);
 }
diff --git a/src/backend/utils/misc/pg_config.c b/src/backend/utils/misc/pg_config.c
index 7a79cbff92..e081eacce7 100644
--- a/src/backend/utils/misc/pg_config.c
+++ b/src/backend/utils/misc/pg_config.c
@@ -69,7 +69,8 @@ pg_config(PG_FUNCTION_ARGS)
 	/* initialize our tuplestore */
 	tupstore = tuplestore_begin_heap(true, false, work_mem);
 
-	configdata = get_configdata(my_exec_path, &configdata_len);
+	configdata = get_configdata(my_exec_path, my_rootdir,
+								&configdata_len);
 	for (i = 0; i < configdata_len; i++)
 	{
 		values[0] = configdata[i].name;
diff --git a/src/bin/Makefile b/src/bin/Makefile
index 8b870357a1..ec0534422e 100644
--- a/src/bin/Makefile
+++ b/src/bin/Makefile
@@ -15,6 +15,7 @@ include $(top_builddir)/src/Makefile.global
 
 SUBDIRS = \
 	initdb \
+	pg \
 	pg_archivecleanup \
 	pg_basebackup \
 	pg_checksums \
diff --git a/src/bin/initdb/Makefile b/src/bin/initdb/Makefile
index 7e23754780..409247f22f 100644
--- a/src/bin/initdb/Makefile
+++ b/src/bin/initdb/Makefile
@@ -47,13 +47,13 @@ localtime.c: % : $(top_srcdir)/src/timezone/%
 	rm -f $@ && $(LN_S) $< .
 
 install: all installdirs
-	$(INSTALL_PROGRAM) initdb$(X) '$(DESTDIR)$(bindir)/initdb$(X)'
+	$(INSTALL_PROGRAM) initdb$(X) '$(DESTDIR)$(libexecdir)/initdb$(X)'
 
 installdirs:
-	$(MKDIR_P) '$(DESTDIR)$(bindir)'
+	$(MKDIR_P) '$(DESTDIR)$(libexecdir)'
 
 uninstall:
-	rm -f '$(DESTDIR)$(bindir)/initdb$(X)'
+	rm -f '$(DESTDIR)$(libexecdir)/initdb$(X)'
 
 clean distclean maintainer-clean:
 	rm -f initdb$(X) $(OBJS) localtime.c
diff --git a/src/bin/initdb/initdb.c b/src/bin/initdb/initdb.c
index 67021a6dc1..475b72e260 100644
--- a/src/bin/initdb/initdb.c
+++ b/src/bin/initdb/initdb.c
@@ -2422,8 +2422,8 @@ setup_bin_paths(const char *argv0)
 {
 	int			ret;
 
-	if ((ret = find_other_exec(argv0, "postgres", PG_BACKEND_VERSIONSTR,
-							   backend_exec)) < 0)
+	if ((ret = find_other_cmd(argv0, "postgres", PG_BACKEND_VERSIONSTR,
+							  backend_exec)) < 0)
 	{
 		char		full_path[MAXPGPATH];
 
diff --git a/src/bin/initdb/t/002_redirect.pl b/src/bin/initdb/t/002_redirect.pl
new file mode 100644
index 0000000000..5a2176b32b
--- /dev/null
+++ b/src/bin/initdb/t/002_redirect.pl
@@ -0,0 +1,17 @@
+use strict;
+use warnings;
+use TestLib;
+use Test::More tests => 4;
+
+command_fails_like(
+	['pg', 'initdb'],
+	qr/error: no data directory specified/,
+	'pg initdb fails');
+
+command_ok(
+	['pg', 'initdb', '--version'],
+	'pg initdb version ok');
+
+command_ok(
+	['pg', 'initdb', '--help'],
+	'pg initdb help ok');
diff --git a/src/bin/pg/.gitignore b/src/bin/pg/.gitignore
new file mode 100644
index 0000000000..f21dfa43a0
--- /dev/null
+++ b/src/bin/pg/.gitignore
@@ -0,0 +1,4 @@
+/pg
+/pg_libdir_relpath.h
+
+/tmp_check/
diff --git a/src/bin/pg/Makefile b/src/bin/pg/Makefile
new file mode 100644
index 0000000000..5ac883ce10
--- /dev/null
+++ b/src/bin/pg/Makefile
@@ -0,0 +1,48 @@
+#-------------------------------------------------------------------------
+#
+# Makefile for src/bin/pg
+#
+# Portions Copyright (c) 1996-2020, PostgreSQL Global Development Group
+# Portions Copyright (c) 1994, Regents of the University of California
+#
+# src/bin/pg/Makefile
+#
+#-------------------------------------------------------------------------
+
+PGFILEDESC = "pg - consolidated PostgreSQL command line interface client"
+PGAPPICON=win32
+
+subdir = src/bin/pg
+top_builddir = ../../..
+include $(top_builddir)/src/Makefile.global
+
+override CPPFLAGS := -I$(libpq_srcdir) $(CPPFLAGS)
+LDFLAGS_INTERNAL += -L$(top_builddir)/src/fe_utils -lpgfeutils $(libpq_pgport)
+
+OBJS = \
+	$(WIN32RES) \
+	pg.o
+
+all: pg
+
+pg: $(OBJS) | submake-libpq submake-libpgport submake-libpgfeutils
+	$(CC) $(CFLAGS) $(OBJS) $(LDFLAGS) $(LDFLAGS_EX) $(LIBS) -o $@$(X)
+
+install: all installdirs
+	$(INSTALL_PROGRAM) pg$(X) '$(DESTDIR)$(bindir)'/pg$(X)
+
+installdirs:
+	$(MKDIR_P) '$(DESTDIR)$(bindir)'
+
+check:
+	$(prove_check)
+
+installcheck:
+	$(prove_installcheck)
+
+uninstall:
+	rm -f $(addprefix '$(DESTDIR)$(bindir)'/, pg$(X))
+
+clean distclean maintainer-clean:
+	rm -f pg$(X) $(OBJS) pg.o
+	rm -rf tmp_check
diff --git a/src/bin/pg/pg.c b/src/bin/pg/pg.c
new file mode 100644
index 0000000000..2341843fcd
--- /dev/null
+++ b/src/bin/pg/pg.c
@@ -0,0 +1,194 @@
+/*-------------------------------------------------------------------------
+ *
+ * pg --- consolidated PostgreSQL command line interface client
+ *
+ * This code is released under the terms of the PostgreSQL License.
+ *
+ * Portions Copyright (c) 1996-2020, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ * src/bin/pg/pg.c
+ *-------------------------------------------------------------------------
+ */
+
+#include "postgres_fe.h"
+
+#include <stdio.h>
+
+#include "common/logging.h"
+#include "lib/stringinfo.h"
+#include "port.h"
+
+/* internal vars */
+static const char *progname;
+
+/* Map user supplied command names to installed executable names. */
+typedef struct NameMap {
+	const char *cmdname;
+	const char *executable;
+} NameMap;
+
+/*
+ * The standard format is that "name" => "pg_name", but this is not so
+ * for some executables, and for compatibility we don't want to change
+ * the executable name.  Instead, nonstandard names are listed here.
+ */
+const NameMap name_map[] = {
+	{ .cmdname = "clusterdb", .executable = "clusterdb" },
+	{ .cmdname = "createdb", .executable = "createdb" },
+	{ .cmdname = "createuser", .executable = "createuser" },
+	{ .cmdname = "dropdb", .executable = "dropdb" },
+	{ .cmdname = "dropuser", .executable = "dropuser" },
+	{ .cmdname = "initdb", .executable = "initdb" },
+	{ .cmdname = "bench", .executable = "pgbench" },
+	{ .cmdname = "reindexdb", .executable = "reindexdb" },
+	{ .cmdname = "vacuumdb", .executable = "vacuumdb" },
+	{ .cmdname = NULL }
+};
+
+static char *executable_for_command(const char *cmdname);
+static void usage(const char *progname);
+
+int
+main(int argc, char *argv[])
+{
+	setvbuf(stdout, NULL, _IONBF, 0);
+	pg_logging_init(argv[0]);
+	set_pglocale_pgservice(argv[0], PG_TEXTDOMAIN("pg"));
+	progname = get_progname(argv[0]);
+
+	/*
+	 * Most options are handled in the various sub-command executables, not
+	 * here.  The only options checked for here are ones that `pg' will handle
+	 * even when there is no sub-command to which the arguments will be handed
+	 * off.  For now, this is just help and version information.
+	 */
+	if (argc > 1)
+	{
+		char	   *found_path;
+		char	   *executable;
+		char		cmd_version[MAXPGPATH + 512];
+
+		found_path = pg_malloc(MAXPGPATH);
+
+		/* Handle recognized options */
+		if (strcmp(argv[1], "--help") == 0 || strcmp(argv[1], "-?") == 0)
+		{
+			usage(progname);
+			exit(0);
+		}
+		if (strcmp(argv[1], "--version") == 0 || strcmp(argv[1], "-V") == 0)
+		{
+			puts("pg (PostgreSQL) " PG_VERSION);
+			exit(0);
+		}
+
+		/* If it is an unrecognized option, return an appropriate error */
+		if (argv[1][0] == '-')
+		{
+			fprintf(stderr,_("%s: error: invalid option: %s\n"), progname, argv[1]);
+			exit(1);
+		}
+
+		/* Otherwise, try to interpret the argument as a command name */
+		executable = executable_for_command(argv[1]);
+		snprintf(cmd_version, sizeof(cmd_version), "%s (PostgreSQL) %s\n", executable, PG_VERSION);
+		if (find_other_cmd(argv[0], executable, cmd_version, found_path) == 0)
+		{
+			StringInfoData		cmd;
+			int					argidx;
+			int					ret;
+
+			/*
+			 * Construct a command string to hand to system() from argv[1..n], noting that
+			 * argv[1] is the command name and needs to be rewritten as an absolute path
+			 * to the appropriate executable.  For argv[2..n], we do no processing, but
+			 * need to be careful to handle any escaping and quoting rules for the system.
+			 */
+			initStringInfo(&cmd);
+			appendStringInfo(&cmd, "%s", found_path);
+			for (argidx = 2; argidx < argc; argidx++)
+			{
+				/* XXX: Is this escaping sufficient? */
+				char *arg = escape_single_quotes_ascii(argv[argidx]);
+				appendStringInfo(&cmd, " %s", arg);
+			}
+
+			ret = system(cmd.data);
+			if (ret)
+			{
+				fprintf(stderr,_("%s: command failed: %s\n"), progname, cmd.data);
+				exit(ret >> 8);
+			}
+			exit(0);
+		}
+
+		/* It's either an unrecognized command or garbage.  Charitably assume it is a command */
+		fprintf(stderr,_("%s: error: unrecognized command: %s\n"), progname, argv[1]);
+		exit(1);
+	}
+
+	fprintf(stderr,_("%s: missing command\n"), progname);
+	exit(1);
+}
+
+static
+char *executable_for_command(const char *cmdname)
+{
+	int i;
+
+	/* Check for nonstandard executable names */
+	for (i = 0; name_map[i].cmdname; i++)
+	{
+		if (strcmp(cmdname, name_map[i].cmdname) == 0)
+			return pstrdup(name_map[i].executable);
+	}
+
+	/* Otherwise, return standard executable name derived from cmdname */
+	return psprintf("pg_%s", cmdname);
+}
+
+/*
+ * print help text
+ */
+static void
+usage(const char *progname)
+{
+	printf(_("%s is the consolidated PostgreSQL command line interface client.\n\n"), progname);
+	printf(_("Usage:\n"));
+	printf(_("  %s [OPTION]... [COMMAND] [COMMAND OPTION]...\n"), progname);
+	printf(_("\nOptions:\n"));
+	printf(_("  -V, --version             output version information, then exit\n"));
+	printf(_("  -?, --help                show this help, then exit\n"));
+	printf(_("\nCommands:\n"));
+	printf(_("  archivecleanup          remove older WAL files from PostgreSQL archives\n"));
+	printf(_("  basebackup              take a base backup of a running PostgreSQL server\n"));
+	printf(_("  bench                   run benchmark tests against a PostgreSQL server\n"));
+	printf(_("  checksums               enable, disable, or verify data checksums in a PostgreSQL database cluster\n"));
+	printf(_("  clusterdb               cluster all previously clustered tables in a database\n"));
+	printf(_("  config                  show information about the installed version of PostgreSQL\n"));
+	printf(_("  controldata             display control information of a PostgreSQL database cluster\n"));
+	printf(_("  createdb                create a PostgreSQL database\n"));
+	printf(_("  createuser              create a new PostgreSQL role\n"));
+	printf(_("  ctl                     initialize, start, stop, or control a PostgreSQL server\n"));
+	printf(_("  dropdb                  remove a PostgreSQL database\n"));
+	printf(_("  dropuser                remove a PostgreSQL role\n"));
+	printf(_("  dump                    dump a database as a text file or to other formats\n"));
+	printf(_("  dumpall                 extract a PostgreSQL database cluster into an SQL script file\n"));
+	printf(_("  initdb                  initialize a PostgreSQL database cluster\n"));
+	printf(_("  isready                 issue a connection check to a PostgreSQL database\n"));
+	printf(_("  receivewal              receive PostgreSQL streaming write-ahead logs\n"));
+	printf(_("  recvlogical             control PostgreSQL logical decoding streams\n"));
+	printf(_("  reindexdb               reindex a PostgreSQL database\n"));
+	printf(_("  resetwal                reset the PostgreSQL write-ahead log\n"));
+	printf(_("  restore                 restore a PostgreSQL database from an archive created by pg_dump\n"));
+	printf(_("  rewind                  resynchronize a PostgreSQL cluster with another copy of the cluster\n"));
+	printf(_("  test_fsync              test all supported fsync() methods\n"));
+	printf(_("  test_timing             test overhead of timing calls and their monotonicity\n"));
+	printf(_("  upgrade                 upgrade a PostgreSQL cluster to a different major version\n"));
+	printf(_("  vacuumdb                clean and analyze a PostgreSQL database\n"));
+	printf(_("  verifybackup            verify a backup against the backup manifest\n"));
+	printf(_("  waldump                 decode and display PostgreSQL write-ahead logs for debugging\n"));
+	printf(_("\nReport bugs to <%s>.\n"), PACKAGE_BUGREPORT);
+	printf(_("%s home page: <%s>\n"), PACKAGE_NAME, PACKAGE_URL);
+}
diff --git a/src/bin/pg/t/001_basic.pl b/src/bin/pg/t/001_basic.pl
new file mode 100644
index 0000000000..d349aa074e
--- /dev/null
+++ b/src/bin/pg/t/001_basic.pl
@@ -0,0 +1,31 @@
+use strict;
+use warnings;
+
+use TestLib;
+use Test::More tests => 13;
+
+program_help_ok('pg');
+program_version_ok('pg');
+program_options_handling_ok('pg');
+
+command_fails_like(
+	[ 'pg', '-a' ],
+	qr/\Qpg: error: invalid option: -a\E/,
+	'pg: invalid command-line arguments');
+
+command_ok(
+	['pg', '--version'],
+	'pg version ok');
+
+command_ok(
+	['pg', '--help'],
+	'pg help ok');
+
+# Checks of various commands, such as 'pg initdb', are implemented
+# in tests named /.*_redirect.pl/ in the test directory of the
+# command in question, so we do not need to duplicate that here.
+# But to help developers who change pg.c and run 'make check' in
+# the pg directory, it helps to have at least one example of that
+# for smoke testing.
+
+command_ok([ 'pg', 'initdb', '--version' ], 'pg redirection');
diff --git a/src/bin/pg_archivecleanup/Makefile b/src/bin/pg_archivecleanup/Makefile
index 49935d6dce..00888294d9 100644
--- a/src/bin/pg_archivecleanup/Makefile
+++ b/src/bin/pg_archivecleanup/Makefile
@@ -17,13 +17,13 @@ pg_archivecleanup: $(OBJS) | submake-libpgport
 	$(CC) $(CFLAGS) $^ $(LDFLAGS) $(LDFLAGS_EX) $(LIBS) -o $@$(X)
 
 install: all installdirs
-	$(INSTALL_PROGRAM) pg_archivecleanup$(X) '$(DESTDIR)$(bindir)/pg_archivecleanup$(X)'
+	$(INSTALL_PROGRAM) pg_archivecleanup$(X) '$(DESTDIR)$(libexecdir)/pg_archivecleanup$(X)'
 
 installdirs:
-	$(MKDIR_P) '$(DESTDIR)$(bindir)'
+	$(MKDIR_P) '$(DESTDIR)$(libexecdir)'
 
 uninstall:
-	rm -f '$(DESTDIR)$(bindir)/pg_archivecleanup$(X)'
+	rm -f '$(DESTDIR)$(libexecdir)/pg_archivecleanup$(X)'
 
 clean distclean maintainer-clean:
 	rm -f pg_archivecleanup$(X) $(OBJS)
diff --git a/src/bin/pg_archivecleanup/t/001_redirect.pl b/src/bin/pg_archivecleanup/t/001_redirect.pl
new file mode 100644
index 0000000000..c68aa89c58
--- /dev/null
+++ b/src/bin/pg_archivecleanup/t/001_redirect.pl
@@ -0,0 +1,17 @@
+use strict;
+use warnings;
+use TestLib;
+use Test::More tests => 4;
+
+command_fails_like(
+	['pg', 'archivecleanup'],
+	qr/error: must specify archive location/,
+	'pg pg_archivecleanup fails');
+
+command_ok(
+	['pg', 'archivecleanup', '--version'],
+	'pg pg_archivecleanup version ok');
+
+command_ok(
+	['pg', 'archivecleanup', '--help'],
+	'pg pg_archivecleanup help ok');
diff --git a/src/bin/pg_archivecleanup/t/010_pg_archivecleanup.pl b/src/bin/pg_archivecleanup/t/010_pg_archivecleanup.pl
index 22782d3042..15a14efb1e 100644
--- a/src/bin/pg_archivecleanup/t/010_pg_archivecleanup.pl
+++ b/src/bin/pg_archivecleanup/t/010_pg_archivecleanup.pl
@@ -27,27 +27,27 @@ sub create_files
 create_files();
 
 command_fails_like(
-	['pg_archivecleanup'],
+	['pg', 'archivecleanup'],
 	qr/must specify archive location/,
 	'fails if archive location is not specified');
 
 command_fails_like(
-	[ 'pg_archivecleanup', $tempdir ],
+	[ 'pg', 'archivecleanup', $tempdir ],
 	qr/must specify oldest kept WAL file/,
 	'fails if oldest kept WAL file name is not specified');
 
 command_fails_like(
-	[ 'pg_archivecleanup', 'notexist', 'foo' ],
+	[ 'pg', 'archivecleanup', 'notexist', 'foo' ],
 	qr/archive location .* does not exist/,
 	'fails if archive location does not exist');
 
 command_fails_like(
-	[ 'pg_archivecleanup', $tempdir, 'foo', 'bar' ],
+	[ 'pg', 'archivecleanup', $tempdir, 'foo', 'bar' ],
 	qr/too many command-line arguments/,
 	'fails with too many command-line arguments');
 
 command_fails_like(
-	[ 'pg_archivecleanup', $tempdir, 'foo' ],
+	[ 'pg', 'archivecleanup', $tempdir, 'foo' ],
 	qr/invalid file name argument/,
 	'fails with invalid restart file name');
 
